import { Initializable } from '@pilotlab/initializable';
import { Signal } from '@pilotlab/signals';
import { List, MapList } from '@pilotlab/collections';
import { ICompareFunction } from '@pilotlab/function-types';
import INode from './interfaces/iNode';
import INodeFactory from './interfaces/iNodeFactory';
import INodeChangeOptions from './interfaces/iNodeChangeOptions';
import INodes from './interfaces/iNodes';
import INodeCreateOptions from './interfaces/iNodeCreateOptions';
import { NodeEventArgs } from './nodeEventArgs';
export declare abstract class NodesBase<TNode extends INode> extends Initializable implements INodes {
    constructor(factory: INodeFactory, parent: TNode, pathSegmentDelimiter?: string, isInitialize?: boolean);
    readonly create: INodeFactory;
    protected p_factory: INodeFactory;
    readonly list: List<TNode>;
    readonly array: Array<TNode>;
    protected p_list: List<TNode>;
    protected p_mapKeys: MapList<string, TNode>;
    readonly parent: TNode;
    internalParent: TNode;
    readonly path: string;
    pathSegmentDelimiter: string;
    protected p_pathSegmentDelimiter: string;
    pathSegmentParentSymbol: string;
    protected p_pathSegmentParentSymbol: string;
    readonly copy: INodes;
    isSignalChange: boolean;
    changed: Signal<NodeEventArgs<any>>;
    childAdded: Signal<NodeEventArgs<TNode>>;
    private _childAdded(args);
    protected p_onChildAdded(args: NodeEventArgs<TNode>): void;
    childAttached: Signal<NodeEventArgs<TNode>>;
    internalChildAttached(args: NodeEventArgs<TNode>): void;
    protected p_onChildAttached(args: NodeEventArgs<TNode>): void;
    childDetached: Signal<NodeEventArgs<TNode>>;
    internalChildDetached(args: NodeEventArgs<TNode>): void;
    protected p_onChildDetached(args: NodeEventArgs<TNode>): void;
    childDeleted: Signal<NodeEventArgs<TNode>>;
    private _childDeleted(args);
    protected p_onChildDeleted(args: NodeEventArgs<TNode>): void;
    childIndexChanged: Signal<NodeEventArgs<any>>;
    private _childIndexChanged(args);
    protected p_onChildIndexChanged(args: NodeEventArgs<TNode>): void;
    internalChanged(args: NodeEventArgs<any>): void;
    internalAttachedAll(changeOptions: INodeChangeOptions): void;
    internalDetachedAll(changeOptions: INodeChangeOptions): void;
    add(child: TNode, index?: number, changeOptions?: INodeChangeOptions): TNode;
    protected p_add(child: TNode, index?: number, changeOptions?: INodeChangeOptions): void;
    addByKey(child: TNode, key: string, index?: number, changeOptions?: INodeChangeOptions): TNode;
    addByPath(child: TNode, path: string, index?: number, changeOptions?: INodeChangeOptions): TNode;
    delete(child: TNode, changeOptions?: INodeChangeOptions): TNode;
    protected p_delete(child: TNode, changeOptions?: INodeChangeOptions): void;
    deleteAt(index: number, changeOptions?: INodeChangeOptions): TNode;
    deleteByKey(key: string, changeOptions?: INodeChangeOptions): TNode;
    clear(changeOptions?: INodeChangeOptions): NodesBase<any>;
    setIndex(child: TNode, index?: number, changeOptions?: INodeChangeOptions): void;
    updateIndices(indexStart?: number, indexEnd?: number, changeOptions?: INodeChangeOptions): void;
    getByKey(key: string): TNode;
    getByPath(path: string, createOptions?: INodeCreateOptions): TNode;
    getOrCreate(path: string, createOptions?: INodeCreateOptions, segmentCreateOptions?: INodeCreateOptions): TNode;
    item(index: number): TNode;
    indexOf(node: TNode): number;
    forEach(handler: (node: TNode) => boolean): void;
    has(node: TNode): boolean;
    hasKey(key: string): boolean;
    compareKeys: ICompareFunction<TNode>;
    compareIndices: ICompareFunction<TNode>;
    compareIndicesDescending: ICompareFunction<TNode>;
    sortByKey(changeOptions?: INodeChangeOptions): NodesBase<TNode>;
    sortByIndex(changeOptions?: INodeChangeOptions): NodesBase<TNode>;
    sortByIndexDescending(changeOptions?: INodeChangeOptions): NodesBase<TNode>;
    sort(comparer: ICompareFunction<TNode>, changeOptions?: INodeChangeOptions): NodesBase<TNode>;
    toMap(isIncludeDataTypes?: boolean): MapList<string, any>;
    toObject(isIncludeDataTypes?: boolean, isIncludeLabels?: boolean, isForceIncludeAll?: boolean): Object;
    toArray(): any[];
    toJson(isIncludeDataTypes?: boolean): string;
}
export default NodesBase;
